% Evaluate the basis function matrix for 10-node tetrahedron.
%
% function val = bfun(self,param_coords)
%
%   Call as:
%      N = bfun (g, pc)
%   where
%      g=gcell,
%      pc=parametric coordinates, -1 < pc(j) < 1, length(pc)=3.
%
function val = bfun(self,param_coords)
    r = param_coords(1);
    s = param_coords(2);
    t = param_coords(3);
    val = [  ...
		(1-r-s-t) * (2*(1-r-s-t)-1);...
		r * (2*r-1);...
		s * (2*s-1);...
		t * (2*t-1);...
		4*(1-r-s-t)*r;...
		4*r*s;...
		4*s*(1-r-s-t);...
		4*(1-r-s-t)*t;...
		4*r*t;...
		4*s*t;...
	];
    return;
end

